/* -----------------------------------------
   

  dash.js
  part of Arduino Mega Server project
  Dashboard functions
-------------------------------------------- */

var currentPage = '';

// Var's for Processing sketch
var dash_marker1 = 0; // ok XML func
var dash_marker2 = 0; // not ok XML func
var dash_marker3 = 0; // in XML func
var liferFloat = 0.0; // lifer volume
var fig = 2; // type of 3D model

// Device online
var TOTAL_NET_DEVICES = 10;
var netDevicesNames = ["SWH", "HOM", "MED", "CMP", "PRN", "MGA", "UN1", "UN2", "LRN", "APC"];

// Timeline graphics
const MAX_CPU_LOAD_BUFFER = 16;
const MAX_GRAPH_BUFFER = 150;
const MAX_FORM_BUFFER = 90;
var bufferCpuLoad1 = [];
var bufferCpuLoad2 = [];
var bufferCpuLoad3 = [];
var bufferCpuLoad4 = [];
var bufferCpuLoad5 = [];
var bufferCpuLoad6 = [];

var bufferElectro1 = [];
var bufferElectro2 = [];
var bufferElectro3 = [];
var bufferElectro4 = [];
var bufferElectro5 = [];
var bufferElectro6 = [];
var bufferElectro7 = [];
var bufferElectro8 = [];
var bufferElectro9 = [];

var bufferLogo1 = [];

var MAX_MODULES = 23;
var modulName = ["RTC",       "ETR",            "SDC",           "SRV",          "MAJ",         "LRT",           "UPL",          "PIR",        "CNT",            "TMP",        "ELC",                "LED",        "KEY",        "PNG",        "NOO",       "NRF",          "DYN",			"RELE",          "LOG",          "DHT",       "BME",         "RADIO",       "PLAYER"];
var modulXml  = ["mRtc",      "mEthernet",      "mSd",           "mServer",      "mMajor",      "mLaurent",      "mUpload",      "mPirs",      "mConts",      "mTemp",      "mPm",                "mLeds",       "mKeys",     "mPing",      "mNoo",      "mNrf24",       "mRobotDyn",	"mRele",         "mTlog",        "mDht",      "mBme",        "mRadio",      "mPlayer"];
var modulId   = ["modul-rtc", "modul-ethernet", "modul-sd-card", "modul-server", "modul-major", "modul-laurent", "modul-upload", "modul-pirs", "modul-contacts", "modul-temp", "dash-modul-electro", "modul-leds", "modul-keys", "modul-ping", "modul-noo", "modul-nrf24",  "modul-dyn",	"modul-rele",    "modul-tlog",   "modul-dht", "modul-bme",   "modul-radio", "modul-player"];

var contName = ["HOM",        "CLO"];
var contXml  = ["cont1",      "cont2"];
var contId   = ["dash-cont1", "dash-cont2"];

var pirName = ["STD",       "HAL",       "KID",       "KUH",       "PRH",       "CLO"];
var pirXml  = ["pir1",      "pir2",      "pir3",      "pir4",      "pir5",      "pir6"];
var pirId   = ["dash-pir1", "dash-pir2", "dash-pir3", "dash-pir4", "dash-pir5", "dash-pir6"];

var digitalPins = ["D2","D3","D4","D5","D6","D7","D8","D9","D10", "D22","D23","D24","D25","D26","D27", "D28", "D29", "D30", "D31", "D32", "D33", "D34", "D35", "D36", "D37", "D38", "D39", "D40", "D41", "D42", "D43", "D44", "D45", "D46", "D47", "D48",];
var analogPins  = ["A0","A1","A2","A3","A4","A5","A6","A7","A8","A9","A10","A11","A12","A13","A14","A15","A16"];
var uniPins		= ["UM35", "UM36", "US35", "US36"];

var UiId = ["volt", "p1", "p2", "p3", "p4", "p5", "p6", "p7", "p8", "p9", "p10", "p11", "p12", "p13"];
var ui = [];

/*
var humDHTdName = ["hDHTd"];
var humDHTdXml  = ["humDHTd"];
var humDHTdId   = ["dash-hDHTd"];
*/
/*
var tempDHTdName = ["tDHTd"];
var tempDHTdXml  = ["tempDHTd"];
var tempDHTdId   = ["dash-tDHTd"];
*/
/*
var BMEName     = ["BMEd"];
var BMEXml      = ["humBMEd"];
var BMEId       = ["dash-BMEd"];
*/
// Main function
function getDashData() {
  dash_marker2 = parseFloat("1.0");
  dash_marker3 = parseFloat("1.0");

  var request = new XMLHttpRequest();
  request.onreadystatechange = function() {
    if (this.readyState == 4) {
      if (this.status == 200) {
        if (this.responseXML != null) {

          dash_marker1 = parseFloat("1.0");
          dash_marker2 = parseFloat("0.0");
		  
//===============================		  
		  //Clock
		  
		  var oldSeconds = 0;

function updateClock() {
 var t = new Date();
 var clockArms = [t.getHours(), t.getMinutes(), t.getSeconds()];
 if (clockArms[2] == oldSeconds) return; //секунды не менялись? выйти
 oldSeconds = clockArms[2];
 
 var c = document.getElementById('clock');
 var ctx = c.getContext('2d');
 //очистить канву:
//ctx.fillStyle = 'white';                  // фон квадрата часов
 ctx.fillRect(0, 0, c.width, c.height);
 //нарисовать контур часов:
 var x = Math.round(c.width/2);
 var y = Math.round(c.height/2);
 var r = Math.round(Math.min(x,y));
 ctx.beginPath(); 
 ctx.arc(x,y,r,0,2*Math.PI,true);
 ctx.fillStyle = 'rgba(200,200,200,1)';// задает фон внутри циферблата
 ctx.fill(); //????????
 ctx.lineWidth = 1;
 ctx.strokeStyle = 'rgba(128,128,128,0)';//-----------------------------окружность!!!!!
 ctx.stroke();
 ctx.closePath();
 //нарисовать метки циферблата и цифры:
 ctx.save();
 ctx.textBaseline = "middle";
 ctx.textAlign = "center";
// ctx.shadowColor = "rgb(128,0,0)";       //тени возле цифр
// ctx.shadowOffsetX = 3;
// ctx.shadowOffsetY = 3;
// ctx.shadowBlur = 6;
 var delta = Math.max(8,Math.round(r/10)); //для размера шрифта и отсечек
 ctx.font = 'bold '+delta+'pt sans-serif';
 var u=Math.PI/2;
 var r1=r-delta;
 for (var i=1; i<=12; i++) {
  ctx.beginPath();
  var x1 = x+Math.round(r1*Math.cos(u)), //так можно узнать позиции делений циферблата
      y1 = y-Math.round(r1*Math.sin(u)),
      x2 = x+Math.round(r*Math.cos(u)),
      y2 = y-Math.round(r*Math.sin(u));
  ctx.strokeStyle = 'rgb(99,99,99)';
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);
  u+=Math.PI/6;
  ctx.stroke();
  ctx.closePath();
  ctx.beginPath();
  ctx.fillStyle = 'rgba(33,33,33,0)';
  //ctx.fillText (''+(13-i),x1,y1); //а так вывести цифры по часовому кругу
  ctx.fill();
  ctx.closePath();
 }
 ctx.restore();
 //нарисовать стрелки:
 clockArms[1] += clockArms[2] / 60;
 clockArms[0] += clockArms[1] / 60;
 drawClockArm(ctx, x, y, clockArms[0] * 30, 2*r/2.5 - 15, 5, 'navy');
 drawClockArm(ctx, x, y, clockArms[1] * 6,  2*r/2.2 - 10, 3, 'darkgreen');
 drawClockArm(ctx, x, y, clockArms[2] * 6,  2*r/2.0 - 6,  2, 'darkred');
}
 
function drawClockArm(ctx, x,y, degrees, len, lineWidth, style) {
 ctx.save();
 ctx.lineWidth = lineWidth;
 ctx.lineCap = 'round';
 ctx.translate(x, y);
 ctx.rotate((degrees - 90) * Math.PI / 180);
 ctx.strokeStyle = style;
 ctx.beginPath();
 ctx.moveTo(-len / 10, 0);
 ctx.lineTo(len, 0);
 ctx.stroke();
 ctx.restore();
}
 
function initClock() {
 window.setInterval(updateClock, 333); //интервал обновления - треть секунды
}

onload = initClock;

//==================================

          // Moduls
          for (var i = 0; i < MAX_MODULES; i++) {
            try {
              var modulRes = this.responseXML.getElementsByTagName(modulXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
                modulRes = "-1";
              }
            try {
              document.getElementById(modulId[i]).innerHTML = modulName[i];
              document.getElementById(modulId[i]).style.background = modulBackground(modulRes);
              document.getElementById(modulId[i]).style.color = modulColor(modulRes);
            } catch (err) { }

            if (i == 13) {var modulPing = modulRes;}
          }

          // Contacts
          for (var i = 0; i < 2; i++) {
            try {
              var dcont = this.responseXML.getElementsByTagName(contXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
                dcont = "-1";
              }
            try {
              document.getElementById(contId[i]).innerHTML = contName[i];
              document.getElementById(contId[i]).style.background = contactBackground(dcont);
              document.getElementById(contId[i]).style.color = contactColor(dcont);
            } catch (err) { }
          }

          // PIR's
          for (var i = 0; i < 6; i++) {
            try {
              var dpir = this.responseXML.getElementsByTagName(pirXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
               // dpir = "-1";
                //alert('Error' + err.name + ":" + err.message + "\n" + err.stack);
              }

           // if (i == 2) {dpir = "-1";}
            try {
              document.getElementById(pirId[i]).innerHTML = pirName[i];
              document.getElementById(pirId[i]).style.background = pirBackground(dpir);
              document.getElementById(pirId[i]).style.color = pirColor(dpir);
            } catch (err) { }
          }

          // Lifer
          var MAX_LIFER = 7;
          var liferStr = '';
          try {
            var lifer = this.responseXML.getElementsByTagName('lifer')[0].childNodes[0].nodeValue;
          } catch (err) {
              lifer = 1;
            }
          liferFloat = parseFloat(lifer);

          for (var i = 0; i < MAX_LIFER; i++) {
            var ch = '·';
            if (i == liferFloat) {ch = '•';}
            liferStr += ch;
          }
          try {
            document.getElementById("lifer").innerHTML = liferStr;
          } catch (err) { }


          // Time & date
          try {
            var time = this.responseXML.getElementsByTagName('time')[0].childNodes[0].nodeValue;
          } catch (err) {
            time = '-';
            }
          try {
            document.getElementById("time").innerHTML = time;
            document.getElementById("time-hide").innerHTML = time;
          } catch (err) { }

          try {
            var day = this.responseXML.getElementsByTagName('day')[0].childNodes[0].nodeValue;
          } catch (err) {
              day = '-';
            }
          try {
            document.getElementById("day").innerHTML = day;
            document.getElementById("day-hide").innerHTML = day;
          } catch (err) {

            }

          try {
            var mon = this.responseXML.getElementsByTagName('month')[0].childNodes[0].nodeValue;
          } catch (err) {
              mon = '-';
            }
          try {
            monthStr = month(mon);
            document.getElementById("month").innerHTML = monthStr;
            document.getElementById("month-hide").innerHTML = monthStr;
          } catch (err) { }

          try {
            var wday = this.responseXML.getElementsByTagName('weekday')[0].childNodes[0].nodeValue;
          } catch (err) {
              wday = '-';
            }
          try {
            weekdayStr = weekday(wday);
            document.getElementById("week-day").innerHTML = weekdayStr;
            document.getElementById("week-day-hide").innerHTML = weekdayStr;
          } catch (err) { }
		  
		   // Temperature
		   
		   try {
            var tempSTR = this.responseXML.getElementsByTagName('tempSTR')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempSTR = "2";
            }

          try {
            var tempSTR_ = Math.round(tempSTR, 1);
            document.getElementById("temp-street").innerHTML = tempSTR_ + "°";
            document.getElementById("temp-street-hide").innerHTML = tempSTR_ + "°";
          } catch (err) { }
		   
		   
		   
		   
		  try {
            var tempHOM = this.responseXML.getElementsByTagName('tempHOM')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempHOM = "2";
            }

          try {
            var tempHOM_ = Math.round(tempHOM, 1);
            document.getElementById("temp-home").innerHTML = tempHOM_ + "°";
            document.getElementById("temp-home-hide").innerHTML = tempHOM_ + "°";
          } catch (err) { }
		  
		  
		    try {
            var tempWRM = this.responseXML.getElementsByTagName('tempWRM')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempWRM = "2";
            }

          try {
            var tempWRM_ = Math.round(tempWRM, 1);
            document.getElementById("temp-serv").innerHTML = tempWRM_ + "°";
            document.getElementById("temp-serv-hide").innerHTML = tempWRM_ + "°";
          } catch (err) { }
/*
          // Temperature
          try {
            var tempSTR = this.responseXML.getElementsByTagName('tempSTR')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempSTR = "-";
            }          
          */
		  
		  
		  
		  		//Hum
	         try {
            var DHThum = this.responseXML.getElementsByTagName('humDHT')[0].childNodes[0].nodeValue;
          } catch (err) {
               DHThum = "37";
            } 

	
		  
	
			
			 try {
            var DHThum_= Math.round(DHThum, 1);
            document.getElementById("dash-DHThum").innerHTML = DHThum_;
            document.getElementById("dash-DHThum-hide").innerHTML = DHThum_;
			
			  } catch (err) { }  
			  
			  
			  
			  		  		//Temp
	         try {
            var DHTtemp = this.responseXML.getElementsByTagName('tempDHT')[0].childNodes[0].nodeValue;
          } catch (err) {
               DHTtemp = "29";
            }  
			
			 try {
            var DHTtemp_= Math.round(DHTtemp, 1);
            document.getElementById("dash-DHTtemp").innerHTML = DHTtemp_;
            document.getElementById("dash-DHTtemp-hide").innerHTML = DHTtemp_;
			
			
			  } catch (err) { }  
			  
			 //======================================================================================= 
		  
			  
			            try {
            var humDHTd = this.responseXML.getElementsByTagName('humDHTd')[0].childNodes[0].nodeValue;
			
			var humCo1 = "";
          } catch (err) {
              humDHTd = '99';
            }
			
		if (humDHTd > 59 || humDHTd < 40){
            humCol = "2"}
		if (humDHTd > 39 || humDHTd < 29){
            humCol = "1"}
        else{
            humCol = "0"}
			
		/*	
          try {
            document.getElementById("dash-hDHTd").innerHTML      = humDHTd;
            document.getElementById("dash-hDHTd-hide").innerHTML = humDHTd;
          } catch (err) {

            }
			
			          try {
           
            document.getElementById("dash-hDHTd").style.background = humDHTdBackground(humDHTd) ;
            document.getElementById("dash-hDHTd").style.color      = humDHTdColor(humDHTd);     
          } catch (err) { }
		 */ 
		           try {
            document.getElementById("dash-hDHTd").innerHTML = humDHTd;
			document.getElementById("dash-hDHTd-hide").innerHTML = humDHTd;
			} catch (err) { }
			  try {
            document.getElementById("dash-hDHTd").style.background = humDHTdBackground(humCol);
            document.getElementById("dash-hDHTd").style.color = humDHTdColor(humCol);
          } catch (err) { }
		 


		
			            try {
            var tempDHTd = this.responseXML.getElementsByTagName('tempDHTd')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempDHTd = '99';
            }
          try {
            document.getElementById("dash-tDHTd").innerHTML      = tempDHTd;
            document.getElementById("dash-tDHTd-hide").innerHTML = tempDHTd;
          } catch (err) { }
			
			          try {
          
            document.getElementById("dash-tDHTd").style.background = tempDHTdBackground(tempDHTd) ;
            document.getElementById("dash-tDHTd").style.color      = tempDHTdColor(tempDHTd);     
          } catch (err) { }
		  
		  
           
			//====================================================================  
		
			
			
						  
			            try {
            var humBMEd = this.responseXML.getElementsByTagName('humBME')[0].childNodes[0].nodeValue;
          } catch (err) {
              humBMEd = '92';
            }
          try {
            document.getElementById("dash-hBMEd").innerHTML = humBMEd;
            document.getElementById("dash-hBMEd-hide").innerHTML = humBMEd;
          } catch (err) {

            }
			
			
			          try {
          
            document.getElementById("dash-hBMEd").style.background = humBMEBackground(humBMEd) ;
            document.getElementById("dash-hBMEd").style.color = humBMEColor(humBMEd);   


  
          } catch (err) { }
		  //=============================================================
		  
		  
		 					  
			            try {
            var tempBMEd = this.responseXML.getElementsByTagName('tempBME')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempBMEd = '92';
            }
          try {
            document.getElementById("dash-tBMEd").innerHTML = tempBMEd;
            document.getElementById("dash-tBMd-hide").innerHTML = tempBMEd;
          } catch (err) {

            }
			
			
			          try {
          
            document.getElementById("dash-tBMEd").style.background = tempBMEBackground(tempBMEd) ;
            document.getElementById("dash-tBMEd").style.color = tempBMEColor(tempBMEd);   


 
          } catch (err) { }

//========================================================================




								  
			            try {
            var presBMEd = this.responseXML.getElementsByTagName('presBME')[0].childNodes[0].nodeValue;
          } catch (err) {
              presBMEd = '92';
            }
          try {
            document.getElementById("dash-pBMEd").innerHTML = presBMEd;
            document.getElementById("dash-pBMEd-hide").innerHTML = presBMEd;
          } catch (err) {

            }
			
			
			          try {
           // document.getElementById('esp').innerHTML = 'ESP';
            document.getElementById("dash-pBMEd").style.background = presBMEBackground(presBMEd) ;
            document.getElementById("dash-pBMEd").style.color = presBMEColor(presBMEd);   


  
          } catch (err) { }
		  
//================================================		  

		//===============================================================	  
		  
          // Voltage & power
          try {
            var dvolt = this.responseXML.getElementsByTagName('voltage')[0].childNodes[0].nodeValue;
          } catch (err) {
              dvolt = "127";
            }
			
			
          try {
            var dvoltage = Math.round(parseInt(dvolt), 0);
            document.getElementById("dash-voltage").innerHTML = dvoltage;
            document.getElementById("dash-voltage-hide").innerHTML = dvoltage;
			
			
			/*
            var tempSTR_ = Math.round(tempSTR, 1);
            document.getElementById("dash-voltage").innerHTML = tempSTR_ + "°";
            document.getElementById("dash-voltage-hide").innerHTML = tempSTR_ + "°";
			
			*/
          } 
		  catch (err) { }
		  
		  

          try {
            var pwr = this.responseXML.getElementsByTagName('power')[0].childNodes[0].nodeValue;
          } catch (err) {
              pwr = "0";
            }
          try {
            var power = Math.round(parseInt(pwr), 0);
            document.getElementById("dash-power").innerHTML = power;
            document.getElementById("dash-power-hide").innerHTML = power;
          } catch (err) { }

          // Uptime
          try {
            var uptm = this.responseXML.getElementsByTagName('uptime')[0].childNodes[0].nodeValue;
          } catch (err) {
              uptm = '-';
            }
          try {
            document.getElementById("dash-uptime").innerHTML = uptm;
          } catch (err) { }

          // free RAM
          try {
            var freeRam = this.responseXML.getElementsByTagName('freeRAM')[0].childNodes[0].nodeValue;
          } catch (err) {
              freeRam = '-';
            }
          try {
            var freeRamPer = Math.round(freeRam / 983, 0);
            document.getElementById("dash-free-ram").innerHTML = freeRam + ' / ' + freeRamPer + '%';
          } catch (err) { }
		  
		  
		   // SD Size
          try {
            var sdSize = this.responseXML.getElementsByTagName('sdSize')[0].childNodes[0].nodeValue;
          } catch (err) {
              sdSize = '666';
            }
          try {
       
            document.getElementById("sd-size").innerHTML = sdSize;
          } catch (err) { }
		  
		  
		 /*
         // files
					  
					  
					  
            try {
              var SDcardsdRootDir = this.responseXML.getElementsByTagName('sdRootDir')[0].childNodes[0].nodeValue;
            } catch (err) {
                SDcardsdRootDir = ".../...";
              }
            //var templ = / /g;                                              // закомм
            //var resStr = SDcardsdRootDir.replace(templ, '<br>');           // закомм
            //document.getElementById("sd-root-dir").innerHTML = resStr;     // закомм
            document.getElementById("sd-root-dir").innerHTML = SDcardsdRootDir;  // я убрал
			
			*/
			
					  //===========================
		  
		            // Pressure

          try {
            var press = this.responseXML.getElementsByTagName('press')[0].childNodes[0].nodeValue;
          } catch (err) {
              press = '0';
            }
			
	      try {
  //          var press = Math.round(parseInt(pwr), 0);
            document.getElementById('dash-press').innerHTML      = press;
            document.getElementById('dash-press-hide').innerHTML = press;
          } catch (err) { }
			//============================
			
            // Rele
			
            try {var releRele1 = this.responseXML.getElementsByTagName('r1mode')[0].childNodes[0].nodeValue;} catch (err) {releRele1 = "-1";}
            switch (releRele1) {
              case "0":
                releRele1_ = 'Выключено';
                break;
              case "1":
                releRele1_ = 'Включено';
                break;
              default:
                releRele1_ = 'состояние неизвестно';
              break;
            }            
            try {document.getElementById("dash-rele").innerHTML = releRele1_;} catch (err) { }
            try {document.getElementById("dash-rele-hide").innerHTML = releRele1_;} catch (err) { }				

          // Cyclos / CPU load
          try {
            var cyclosDelay = this.responseXML.getElementsByTagName('cycDelay')[0].childNodes[0].nodeValue;
          } catch (err) {
              cyclosDelay = '-';
            }
          try {
            var cyclosInSec = this.responseXML.getElementsByTagName('cycInSec')[0].childNodes[0].nodeValue;
          } catch (err) {
              cyclosInSec = '-';
            }

          try {
            load('cpu-load',  1, freeRamPer, '', bufferCpuLoad1, '', 'mem', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          } catch (err) { }
          
          insertTick(16, bufferCpuLoad3);
          
          //try {
          //  load('cpu-load2', 2, cyclosDelay, cyclosInSec, bufferCpuLoad2, bufferCpuLoad3, 'cpu', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          //} catch (err) { }
          
          try {
            load('cpu-load3', 3, cyclosDelay, '', bufferCpuLoad4, '', 'cpu', 'rgba(100, 160, 230, 1)', 'cyan', 'lightblue');
          } catch (err) { }
          try {
            load('cpu-load4', 4, cyclosDelay, cyclosInSec, bufferCpuLoad5, bufferCpuLoad6, 'cpu', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          } catch (err) { }

          // Force
          try {
            var force = this.responseXML.getElementsByTagName('force')[0].childNodes[0].nodeValue;
          } catch (err) {
              force = "-";
            }
          if (force == 1) {
            forceText = 'FRC';
          } else {
              forceText = 'NRM';
            }
          try {
            document.getElementById('force').innerHTML = forceText;
            document.getElementById('force').style.background = forceBackground(force);
            document.getElementById('force').style.color = forceColor(force);
          } catch (err) { }          
          
          // Time provider
          try {
            var timeProv = this.responseXML.getElementsByTagName('timeProv')[0].childNodes[0].nodeValue;
          } catch (err) {
              timeProv = "-";
            }
          switch (timeProv) {
            case "0":
              timeProvText = 'NON';
              break;
            case "1":
              timeProvText = 'NET';
              break;
            default:
              timeProvText = 'RTC';
            break;
          }
          try {
            document.getElementById('time-sync').innerHTML = timeProvText;
            document.getElementById('time-sync').style.background = timeProviderBackground(timeProv);
            document.getElementById('time-sync').style.color = timeProviderColor(timeProv);
          } catch (err) { }
          
          // Auth
          try {
            var auth = this.responseXML.getElementsByTagName('auth')[0].childNodes[0].nodeValue;
          } catch (err) {
              auth = "-";
            }
          var authText = '';
          if (auth == 1) {
            authText = 'AUT';
          } else {
              authText = 'FRE';
            }
          try {
            document.getElementById('auth').innerHTML = authText;
            document.getElementById('auth').style.background = authBackground(auth);
            document.getElementById('auth').style.color = authColor(auth);     
          } catch (err) { }
          try {
            document.getElementById('auth-footer').innerHTML = authText;
            document.getElementById('auth-footer').style.background = authBackground(auth);
            document.getElementById('auth-footer').style.color = authColor(auth);            
          } catch (err) { }
		  
		  
		   // ESP8266
          try {
            var esp = this.responseXML.getElementsByTagName('esp')[0].childNodes[0].nodeValue;
          } catch (err) {esp = "-";}
          try {
            document.getElementById('esp').innerHTML = 'ESP';
            document.getElementById('esp').style.background = espBackground(esp);
            document.getElementById('esp').style.color = espColor(esp);     
          } catch (err) { }
		  
		     // MEGA
          try {
            var mega = this.responseXML.getElementsByTagName('mega')[0].childNodes[0].nodeValue;
          } catch (err) {mega = "-";}
          try {
            document.getElementById('mega').innerHTML = 'MGA';
            document.getElementById('mega').style.background = megaBackground(mega);
            document.getElementById('mega').style.color = megaColor(mega);     
          } catch (err) { }
		  
		  
		  
		  
		  
		  	// Radio
					 
					 
          try {
            var rad = this.responseXML.getElementsByTagName('radio')[0].childNodes[0].nodeValue;
          } catch (err) {rad = "-";}
          try {
            document.getElementById('radio').innerHTML = 'RADIO';
            document.getElementById('radio').style.background = radioBackground(rad);
            document.getElementById('radio').style.color = radioColor(rad);     
          } catch (err) { }
		  
		  
		  		  
          try {
            var radFrec = this.responseXML.getElementsByTagName('radFrec')[0].childNodes[0].nodeValue;
          } catch (err) {
              radFrec = '100,02';
            }
          try {
			  var radFrec_= radFrec / 100 ;
			  
            document.getElementById('rad-Frec').innerHTML = radFrec_ + "0";
            document.getElementById("rad-Frec-hide").innerHTML = radFrec_ + "0";
			

          } catch (err) { }
		  

		  
		  
		  
		  		  
		  	// Player
					 
					 
          try {
            var play = this.responseXML.getElementsByTagName('player')[0].childNodes[0].nodeValue;
          } catch (err) {play = "-";}
          try {
            document.getElementById('player').innerHTML = 'PLAYER';
            document.getElementById('player').style.background = playBackground(play);
            document.getElementById('player').style.color = playColor(play);     
          } catch (err) { }
		  
		  
		  
          
          // Ports page
          if (currentPage == 'ports-page') {
            // digital pins
            for (var i = 0; i < digitalPins.length; i++) {
              try {
                var pinState = this.responseXML.getElementsByTagName(digitalPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  pinState = "-1";
                }
              try {
                document.getElementById(digitalPins[i]).innerHTML        = stateOnOff(pinState);
                document.getElementById(digitalPins[i]).style.background = stateOnOffBackground(pinState);
                document.getElementById(digitalPins[i]).style.color      = stateOnOffColor(pinState);
              } catch (err) { }
            }
            // analog pins
            for (var i = 0; i < analogPins.length; i++) {
              try {
                var aPinState = this.responseXML.getElementsByTagName(analogPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  aPinState = "-1";
                }
              try {
                document.getElementById(analogPins[i]).innerHTML = aPinState;
              } catch (err) { }
            }
          } // ports-page
		  
		  
		  		  // Uni page
          if (currentPage == 'uni-page') {
            // uni pin
            for (var i = 0; i < uniPins.length; i++) {
              try {
                var uniState = this.responseXML.getElementsByTagName(uniPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  uniState = "-1";
                }
              try {
                document.getElementById(uniPins[i]).innerHTML        = stateOnOff(uniState);
                document.getElementById(uniPins[i]).style.background = stateOnOffBackground(uniState);
                document.getElementById(uniPins[i]).style.color      = stateOnOffColor(uniState);
              } catch (err) { }
            }
            // analog pins
            for (var i = 0; i < analogPins.length; i++) {
              try {
                var aPinState = this.responseXML.getElementsByTagName(analogPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  aPinState = "-1";
                }
              try {
                document.getElementById(analogPins[i]).innerHTML = aPinState;
              } catch (err) { }
            }
          }

          // Supply page works
          if (currentPage == 'supply-page') {
            // Electro
            try {
              document.getElementById("volt").innerHTML = dvoltage;
            } catch (err) { }
            try {
              document.getElementById("p1").innerHTML = power;
            } catch (err) { }

            try {
              graph('graph-voltage', 3, dvoltage, '', bufferElectro9, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(204,9,51, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-power', 3, power, '', bufferElectro1, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(213,125,12, 1)', 'lightblue');
            } catch (err) { }

            // Period
            try {
              var period = this.responseXML.getElementsByTagName('period')[0].childNodes[0].nodeValue;
              period -= 100;
            } catch (err) {
                period = "-";
              }
            try {
              var frec = 1 / (period / 1000000);
              document.getElementById("freq").innerHTML = frec.toFixed(2);
            } catch (err) { }

            try {
              graph('graph-freq', 3, frec.toFixed(2), '', bufferElectro7, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(44,77,220, 1)', 'lightblue');
            } catch (err) { }
          } // if (currentPage == 'supply-page')

          // Electro page works
          if (currentPage == 'electro-page') {

            // Electro modul
            try {
              var modulElectro = this.responseXML.getElementsByTagName('modulElectro')[0].childNodes[0].nodeValue;
            } catch (err) {
                modulElectro = '-';
              }

            var modulElectroStatus = "";

            switch (modulElectro) {
              case "0":
                modulElectroStatus = "выключен";
                break;
              case "1":
                modulElectroStatus = "включен";
                break;
              default:
                modulElectroStatus = "отсутствует";
                try {
                  document.getElementById("button-electro").innerHTML = "-";
                  document.getElementById("button-electro").style.background = modulDisable;
                } catch (err) { }
              break;
            }
            try {
              document.getElementById("modul-electro").innerHTML = modulElectroStatus;
            } catch (err) { }

            // Electro
            for (var i = 0; i < 14; i++) {
              try {
                ui[i] = this.responseXML.getElementsByTagName(UiId[i])[0].childNodes[0].nodeValue;
                ui[i] = Math.round(parseInt(ui[i]), 0);
              } catch (err) {
                  ui[i] = "...";
                }
              try {
                document.getElementById(UiId[i]).innerHTML = ui[i];
              } catch (err) { }

            }
            try {
              graph('graph-test', 3, ui[1], '', bufferElectro1, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(204,9,51, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-cond', 3, ui[4], '', bufferElectro2, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(213,125,12, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-plita', 3, ui[2], '', bufferElectro3, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(166,0,151, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-str', 3, ui[3], '', bufferElectro4, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(75,152,190, 1)', 'lightblue');
            } catch (err) { }
            try {
              device('device-plita', 3, ui[2], 'Плита',             200, 500, 900, 1500);
            } catch (err) { }
            try {
              device('device-str',   3, ui[3], 'Стиральная машина', 60, 300, 1500, 2000);
            } catch (err) { }
            try {
              device('device-cond',  3, ui[4], 'Кондиционер',       60, 100, 600, 1500);
            } catch (err) { }
            
            // draw bar
            //drawBar(p2, p3, p4, p6, p7, p8, p9, p10, p11, p12, p13);
          } // if (currentPage == 'electro-page')


          // Online net devices
          for (var i = 0; i < TOTAL_NET_DEVICES; i++) {
            var j = i + 1;
            var tagOnline = "dash-online" + j;
            if (modulPing == 0 || modulPing == 1) {
              try {
                var dOnline = this.responseXML.getElementsByTagName(netDevicesNames[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  dOnline = "-1";
                }
              try {
                document.getElementById(tagOnline).innerHTML = netDevicesNames[i];
                document.getElementById(tagOnline).style.background = onlineBackground(dOnline);
                document.getElementById(tagOnline).style.color = onlineColor(dOnline);
              } catch (err) { }
            } else {
                try {
                  document.getElementById(tagOnline).style.display = "none";
                } catch (err) { }
              }
          } // for (var i = 0; i < TOTAL_NET_DEVICES; i++)

        } // if (this.responseXML != null)
      } // if (this.status == 200)
    } // if (this.readyState == 4)
  } // request.onreadystatechange = function()

  dash_marker1 = parseFloat("0.0");

  // send HTTP GET request with LEDs to switch on/off if any
  request.open("GET", "request_dash" + currentPage + randomNoCache(), true);
  request.send(null);
  setTimeout('getDashData()', 2000);
  dash_marker3 = parseFloat("0.0");
} // getDashData()

/* end */
