/* -----------------------------------------
   

  scripts.js 0.16
  part of Arduino Mega Server project
-------------------------------------------- */

// Date & time

function month(mon) {
  switch (mon) {
    case "1": return "января"; break;
    case "2": return "февраля"; break;
    case "3": return "марта"; break;
    case "4": return "апреля"; break;
    case "5": return "мая"; break;
    case "6": return "июня"; break;
    case "7": return "июля"; break;
    case "8": return "августа"; break;
    case "9": return "сентября"; break;
    case "10": return "октября"; break;
    case "11": return "ноября"; break;
    case "12": return "декабря"; break;
    default: return ""; break;
  }
}

function weekday(day) {
  switch (day) {
    case "1": return "Воскресенье"; break;
    case "2": return "Понедельник"; break;
    case "3": return "Вторник"; break;
    case "4": return "Среда"; break;
    case "5": return "Четверг"; break;
    case "6": return "Пятница"; break;
    case "7": return "Суббота"; break;
     default: return ""; break;
  }
}

// Network

function randomNoCache() {
  var random = Math.round(Math.random() * 10000);
  if (random < 10) {random *= 1000;}
  if (random < 100) {random *= 100;}
  if (random < 1000) {random *= 10;}
  return "&nocache=" + random;
}

// Data colors

var modulDisable = "#555555";
var modulPassive = "#887711";
var modulActive  = "#1188dd";

function modulBackground       (state) {switch (state) {case "0": return modulPassive; break; case "1": return modulActive; break; default: return modulDisable; break;}}
function modulColor            (state) {switch (state) {case "0": return "#eeeeee"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function forceBackground       (state) {switch (state) {case "0": return "#6EA1D2"; break; case "1": return "#F4A509"; break; default: return "#555555"; break;}}
function forceColor            (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}
function timeProviderBackground(state) {switch (state) {case "1": return "#91A46B"; break; case "2": return "#A28D85"; break; default: return "#555555"; break;}}
function timeProviderColor     (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; case "2": return "#ffffff"; break; default: return "#aaaaaa"; break;}}
function authBackground        (state) {switch (state) {case "0": return "#03B882"; break; case "1": return "#DA7063"; break; default: return "#555555"; break;}}
function authColor             (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}
function espBackground         (state) {switch (state) {case "0": return "#DA7063"; break; case "1": return "#04A9AE"; break; default: return "#555555"; break;}}
function espColor              (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function megaBackground        (state) {switch (state) {case "0": return "#DA7063"; break; case "1": return "#04A9AE"; break; default: return "#555555"; break;}}
function megaColor             (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function onlineBackground      (state) {switch (state) {case "0": return "#555555"; break; case "1": return "#3EAF3B"; break; default: return "#555555"; break;}}
function onlineColor           (state) {switch (state) {case "0": return "#aaaaaa"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function contactBackground     (state) {switch (state) {case "0": return "#68974C"; break; case "1": return "#B93737"; break; default: return "#555555"; break;}}
function contactColor          (state) {switch (state) {case "0": return "#eeeeee"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}
function pirBackground         (state) {switch (state) {case "0": return "#0999E9"; break; case "1": return "#eedd22"; break; default: return "#555555"; break;}}
function pirColor              (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#555555"; break; default: return "#aaaaaa"; break;}}

function stateOnOffBackground  (state) {switch (state) {case "0": return "#555555"; break; case "1": return "#FAF39B"; break; default: return "#555555"; break;}}
function stateOnOffColor       (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#000000"; break; default: return "#aaaaaa"; break;}}
function stateOnOff            (state) {switch (state) {case "0": return "OFF";     break; case "1": return "ON";      break; default: return "-";       break;}}


function radBackground        (state) {switch (state) {case "0": return "#DA7063"; break; case "1": return "#04A9AE"; break; default: return "#555555"; break;}}
function radColor             (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function playBackground       (state) {switch (state) {case "0": return "#DA7063"; break; case "1": return "#04A9AE"; break; default: return "#555555"; break;}}
function playColor            (state) {switch (state) {case "0": return "##0999E9"; break; case "1": return "#ffffff"; break; default: return "#0999E9"; break;}}


//function humCo1Background    (state) {switch (state) { default: return "#04A9AE"; break;}}

//function humCo1Color         (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; case "2": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function humDHTdBackground    (state) {switch (state) { default: return "#04A9AE"; break;}}
function humDHTdColor         (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; case "2": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

function tempDHTdBackground   (state) {switch (state) { default: return "#04A9AE"; break;}}
function tempDHTdColor        (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; case "2": return "#ffffff"; break; default: return "#aaaaaa"; break;}}

/*
function humBMEBackground        (state) {switch (state) {case "0": return "#DA7063"; break; case "1": return "#04A9AE"; break; default: return "#555555"; break;}}
function humBMEColor             (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#ffffff"; break; default: return "#aaaaaa"; break;}}
*/
function humBMEBackground     (state) {switch (state) { default: return "#FAEBD7"; break;}}
function humBMEColor          (state) {switch (state) {case "0": return "#555555	"; break; case "1": return "#555555	"; break; default: return "#aaaaaa"; break;}}

function tempBMEBackground    (state) {switch (state) { default: return "#FAEBD7"; break;}}
function tempBMEColor         (state) {switch (state) {case "0": return "#555555	"; break; case "1": return "#555555	"; break; default: return "#aaaaaa"; break;}}

function presBMEBackground    (state) {switch (state) { default: return "#FAEBD7"; break;}}
function presBMEColor         (state) {switch (state) {case "0": return "#555555	"; break; case "1": return "#555555	"; break; default: return "#aaaaaa"; break;}}

function humColColor          (state) {switch (state) {case "0": return "#ffffff"; break; case "1": return "#555555"; break; case "2": return "#04A9AE"; break; default: return "#aaaaaa"; break;}}
function humCo1Background     (state) {switch (state) { default: return "#04A9AE"; break;}}
/* ------------------------------
  Graphics Logo Works
--------------------------------- */

var shiftX = 20;
var shiftY = 10;
var lenX = 136;
var lenY = 136;
var logoColor = 'rgba(120, 170, 220, 1)';
var logoColorLight = 'rgba(50, 110, 150, 1)';
var width = 1;

function drawBorder(x, y, lenX, lenY, color) {
  var cor = 2;
  drawXline(x - cor, x + lenX + cor, y - 1,        1, color);
  drawXline(x - cor, x + lenX + cor, y + lenY + 1, 1, color);
  drawYline(x - 1,        y - cor, y + lenY + cor, 1, color);
  drawYline(x + lenX + 1, y - cor, y + lenY + cor, 1, color);
}

function clearLogo(place) {
  // context works
  try {
    element = document.getElementById(place);
    context = element.getContext('2d');
  } catch (err) {
      return;
    }

  // clear background
  context.fillStyle = 'black';
  context.fillRect(0, 0, element.width, element.height);

  // draw border
  drawBorder(shiftX, shiftY, lenX, lenY, logoColor);
}

/* ------------------------------
  Ping-Pong logo [1]

--------------------------------- */

function drawPong(place, x, y, color) {
  // context works
  try {
    element = document.getElementById(place);
    context = element.getContext('2d');
  } catch (err) {
      return;
    }
  
  // clear background
  context.fillStyle = 'black';
  context.fillRect(0, 0, element.width, element.height);

  // draw Pong
  context.fillStyle = color;
  context.arc(shiftX + x, shiftY + y, 6, 0, Math.PI * 2);
  context.fill();
  context.beginPath();
  context.fill();

  // draw border
  drawBorder(shiftX, shiftY, lenX, lenY, logoColor);
} // drawPong( )

var pongDim = 6;
var pongMinX = 0 + pongDim;
var pongMinY = 0 + pongDim;
var pongMaxX = 136 - pongDim;
var pongMaxY = 136 - pongDim;
var dX = 1;
var dY = 1;
var pongX = 7;
var pongY = 25;

function logoPong() {
  var pongColor = logoColor;

  if (pongX < pongMinX || pongX > pongMaxX) {dX = -dX;}
  if (pongY < pongMinY || pongY > pongMaxY) {dY = -dY;}
  if (pongY == 100) {pongY += dY * 2;}

  pongX += dX;
  pongY += dY;

  drawPong('logo', pongX, pongY, pongColor);
}

/* ------------------------------
  Radar logo [2]

--------------------------------- */

function drawRadar(place, liferPos, width, color) {
  var halfX = lenX / 2;
  var halfY = lenY / 2;
  liferPos = 34 - liferPos;

  // context works
  try {
    element = document.getElementById(place);
    context = element.getContext('2d');
  } catch (err) {
      return;
    }
  
  // draw radar
  context.lineWidth = width;
  context.beginPath();
  context.moveTo(shiftX, shiftY + (lenY - liferPos * 4));
  context.lineTo(shiftX + halfX, shiftY + halfX);
  context.lineTo(shiftX + (lenX - liferPos * 4), shiftY + lenY);
  context.moveTo(shiftX + (lenX - liferPos * 4), shiftY + lenY);
  context.moveTo(shiftX + (lenX - liferPos * 4), shiftY);
  context.lineTo(shiftX + halfX, shiftY + halfX);
  context.lineTo(shiftX + lenX, shiftY + (lenY - liferPos * 4));
  context.moveTo(shiftX + lenX, shiftY + (lenY - liferPos * 4));
  context.closePath();
  context.strokeStyle = color;
  context.stroke();

  // draw border
  drawBorder(shiftX, shiftY, lenX, lenY, logoColorLight);
} // drawRadar( )

var liferLogo = 0;
var phase = 1;
var radarColor = logoColor;

function logoRadar() {
  liferLogo++;
  if (liferLogo > 34) {liferLogo = 0;}

  if (liferLogo == 0) {
    phase = -phase;
    if (phase == 1) {
      radarColor = logoColor;
      width = 1;
    } else {
        radarColor = 'black';
        width = 2;
      }
  }
  // draw
  drawRadar('logo', liferLogo, width, radarColor);
}

/* ------------------------------
  Random Rects logo [3]

--------------------------------- */

function drawRect(place, x, y, color) {
  var step = 12;
  var shift = 3;
  var dim = 10;

  // context works
  try {
    element = document.getElementById(place);
    context = element.getContext('2d');
  } catch (err) {
      return;
    }
  
  // draw rect
  context.fillStyle = color;
  context.fillRect(shiftX + x*step + shift, shiftY + y*step + shift, dim, dim);
  context.fill();
  context.beginPath();
  context.fill();

  // draw border
  drawBorder(shiftX, shiftY, lenX, lenY, logoColorLight);
}

function logoRandomRects() {
  var show = 'rgba(100, 120, 200, 0.7)';
  var hide ='rgba(0, 0, 0, 1)';

  // random position
  var x = Math.round(Math.random() * 10);
  var y = Math.round(Math.random() * 10);

  // random color
  var colorRnd = Math.round(Math.random() * 1000);
  if (colorRnd > 500) {
    var color = show;
  } else {
      var color = hide;
    }

  // anomal colors
  if (colorRnd == 60) {color = 'rgba(40, 218, 34, 1)';} // green
  if (colorRnd == 70) {color = 'rgba(228, 185, 34, 1)';} // yellow
  if (colorRnd == 80) {color = 'rgba(218, 50, 34, 1)';} // red

  // draw
  drawRect('logo', x, y, color);
}

/* ------------------------------
  Function logoRotator()
    Show graphics logo
--------------------------------- */

var curLogo = 0;
var maxLogo = 3;
var logo1timer;
var logo2timer;
var logo3timer;
var netActivtimer;

function logoRotator() {

  // network act
  clearInterval(netActivtimer);
  netActivtimer = setInterval('netLoad()', 1000);
  
  // random logo
  if (curLogo == 0) { // start
    var logoRnd = Math.round(Math.random() * 10);
    curLogo = 1;
    if (logoRnd > 0 && logoRnd <= 3) {curLogo = 1;}
    if (logoRnd > 3 && logoRnd <= 6) {curLogo = 2;}
    if (logoRnd > 6 && logoRnd <= 10) {curLogo = 3;}
  } else { // cycle
      curLogo++;
    }

  if (curLogo > maxLogo) {curLogo = 1;}

  // clear timers
  clearInterval(logo1timer);
  clearInterval(logo2timer);
  clearInterval(logo3timer);

  // show current logo
  switch (curLogo) {
    case 1:
      logo1timer = setInterval('logoPong()', 20);
      break;
    case 2:
      clearLogo('logo');
      logo2timer = setInterval('logoRadar()', 80);
      break;
    case 3:
      clearLogo('logo');
      logo3timer = setInterval('logoRandomRects()', 120);
      break;
    default:
      break;
    } // switch (type)

  // change logo (period 1 minute)
  setTimeout('logoRotator()', 60000);
} // logoRotator()

function rndNumber() {
  var random = Math.round(Math.random() * 100000);
  if (random < 10) {random *= 1000;}
  if (random < 100) {random *= 100;}
  if (random < 1000) {random *= 10;}
  return random;
}

function genNumber() {
  try {
    var magicNumber = rndNumber();
    document.getElementById("magic-number").innerHTML = magicNumber;
  } catch (err) { }
}

function netLoad() {
  try {
    load('cpu-load2', 2, 0, 0, bufferCpuLoad2, bufferCpuLoad3, 'net', 'rgba(100, 160, 230, 1)', 'rgba(100, 160, 230, 1)', 'rgba(100, 160, 230, 1)');
  } catch (err) { }
}

/*
// clock


var oldSeconds = 0;

function updateClock() {
 var t = new Date();
 var clockArms = [t.getHours(), t.getMinutes(), t.getSeconds()];
 if (clockArms[2] == oldSeconds) return; //секунды не менялись? выйти
 oldSeconds = clockArms[2];
 
 var c = document.getElementById('clock');
 var ctx = c.getContext('2d');
 //очистить канву:
//ctx.fillStyle = 'white';                  // фон квадрата часов
 ctx.fillRect(0, 0, c.width, c.height);
 //нарисовать контур часов:
 var x = Math.round(c.width/2);
 var y = Math.round(c.height/2);
 var r = Math.round(Math.min(x,y));
 ctx.beginPath(); 
 ctx.arc(x,y,r,0,2*Math.PI,true);
 ctx.fillStyle = 'rgba(200,200,200,1)';// задает фон внутри циферблата
 ctx.fill(); //????????
 ctx.lineWidth = 1;
 ctx.strokeStyle = 'rgba(128,128,128,0)';//-----------------------------окружность!!!!!
 ctx.stroke();
 ctx.closePath();
 //нарисовать метки циферблата и цифры:
 ctx.save();
 ctx.textBaseline = "middle";
 ctx.textAlign = "center";
// ctx.shadowColor = "rgb(128,0,0)";       //тени возле цифр
// ctx.shadowOffsetX = 3;
// ctx.shadowOffsetY = 3;
// ctx.shadowBlur = 6;
 var delta = Math.max(8,Math.round(r/10)); //для размера шрифта и отсечек
 ctx.font = 'bold '+delta+'pt sans-serif';
 var u=Math.PI/2;
 var r1=r-delta;
 for (var i=1; i<=12; i++) {
  ctx.beginPath();
  var x1 = x+Math.round(r1*Math.cos(u)), //так можно узнать позиции делений циферблата
      y1 = y-Math.round(r1*Math.sin(u)),
      x2 = x+Math.round(r*Math.cos(u)),
      y2 = y-Math.round(r*Math.sin(u));
  ctx.strokeStyle = 'rgb(99,99,99)';
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);
  u+=Math.PI/6;
  ctx.stroke();
  ctx.closePath();
  ctx.beginPath();
  ctx.fillStyle = 'rgba(33,33,33,0)';
  //ctx.fillText (''+(13-i),x1,y1); //а так вывести цифры по часовому кругу
  ctx.fill();
  ctx.closePath();
 }
 ctx.restore();
 //нарисовать стрелки:
 clockArms[1] += clockArms[2] / 60;
 clockArms[0] += clockArms[1] / 60;
 drawClockArm(ctx, x, y, clockArms[0] * 30, 2*r/2.5 - 15, 5, 'navy');
 drawClockArm(ctx, x, y, clockArms[1] * 6,  2*r/2.2 - 10, 3, 'darkgreen');
 drawClockArm(ctx, x, y, clockArms[2] * 6,  2*r/2.0 - 6,  2, 'darkred');
}
 
function drawClockArm(ctx, x,y, degrees, len, lineWidth, style) {
 ctx.save();
 ctx.lineWidth = lineWidth;
 ctx.lineCap = 'round';
 ctx.translate(x, y);
 ctx.rotate((degrees - 90) * Math.PI / 180);
 ctx.strokeStyle = style;
 ctx.beginPath();
 ctx.moveTo(-len / 10, 0);
 ctx.lineTo(len, 0);
 ctx.stroke();
 ctx.restore();
}
 
function initClock() {
 window.setInterval(updateClock, 333); //интервал обновления - треть секунды
}

onload = initClock;
*/

/* end */
